package com.usky.issue.service.impl;


import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.usky.issue.domain.*;
import com.usky.issue.mapper.SpDeviceDataMapper;
import com.usky.issue.service.SpDeviceDataService;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.issue.service.SpOwnerStatusService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * <p>
 * 设备数据表 服务实现类
 * </p>
 *
 * @author fu
 * @since 2024-01-24
 */
@Service
public class SpDeviceDataServiceImpl extends AbstractCrudService<SpDeviceDataMapper, SpDeviceData> implements SpDeviceDataService {
    @Autowired
    private SpOwnerStatusService spOwnerStatusService;


    @Override
    @DS("usky-website")
    public void updateData() {
        QueryWrapper<SpDeviceData> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByDesc("id").last("LIMIT 1");
        SpDeviceData lastStatus = baseMapper.selectOne(queryWrapper);
        List<SpOwnerStatus> devicesToUpdate;
        if (lastStatus == null) {
            devicesToUpdate = spOwnerStatusService.getOwners();
        } else {
            devicesToUpdate = spOwnerStatusService.getOwnersAfter(lastStatus.getId());
        }
        for (SpOwnerStatus owner : devicesToUpdate) {
            SpDeviceData spDeviceData = new SpDeviceData();
            spDeviceData.setId(owner.getId().intValue());
            spDeviceData.setDeviceCode(owner.getDeviceId());
            spDeviceData.setDeviceType(owner.getDwtype());
            spDeviceData.setPointName(owner.getPointName());
            spDeviceData.setPointCode(owner.getPointCode());
            spDeviceData.setPointData(owner.getPointData());
            spDeviceData.setDataTime(owner.getDataTime());
            spDeviceData.setDataContent(owner.getContent());
            baseMapper.insert(spDeviceData);
        }
    }
}
