package com.usky.issue.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.usky.issue.domain.SpDevice;
import com.usky.issue.domain.SpOwner;
import com.usky.issue.mapper.SpDeviceMapper;
import com.usky.issue.service.SpDeviceService;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.issue.service.SpOwnerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.util.List;

/**
 * <p>
 * 设备信息表 服务实现类
 * </p>
 *
 * @author fu
 * @since 2024-01-24
 */
@Service
public class SpDeviceServiceImpl extends AbstractCrudService<SpDeviceMapper, SpDevice> implements SpDeviceService {
    @Autowired
    private SpOwnerService spOwnerService;

    @Override
    @DS("usky-website")
    public void updateDevice() {
        QueryWrapper<SpDevice> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByDesc("id").last("LIMIT 1");
        SpDevice lastDevice = baseMapper.selectOne(queryWrapper);
        List<SpOwner> devicesToUpdate;
        if (lastDevice == null) {
            devicesToUpdate = spOwnerService.getOwners(spOwnerService.getDeviceCodes());
        } else {
            devicesToUpdate = spOwnerService.getOwnersAfter(lastDevice.getId());
        }
        for (SpOwner owner : devicesToUpdate) {
            SpDevice spDevice = new SpDevice();
            spDevice.setId(owner.getId());
            spDevice.setDeviceCode(owner.getOwnerCode());
            spDevice.setDeviceName(owner.getOwnerName());
            spDevice.setInstallAddress(owner.getUnitinfo());
            spDevice.setInstallationFloor(owner.getLouyu());
            spDevice.setInstallationTime(owner.getInstallTime());
            spDevice.setDeviceType(owner.getDwtype());
            spDevice.setCampus(spOwnerService.getCampus(owner.getCompany()));
            baseMapper.insert(spDevice);
        }
    }
}
