package com.usky.issue.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.common.core.util.StringUtils;
import com.usky.issue.domain.*;
import com.usky.issue.mapper.SpEf2017Mapper;
import com.usky.issue.service.SpEf2017Service;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.issue.service.SpOwnerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author fu
 * @since 2024-01-24
 */
@Service
@DS("jdxf")
public class SpEf2017ServiceImpl extends AbstractCrudService<SpEf2017Mapper, SpEf2017> implements SpEf2017Service {
    @Autowired
    private SpOwnerService spOwnerService;


    /**
     * 告警信息更新
     * @return
     */
    @Override
    public List<SpEf2017> getOwners() {
        List<String> codes = spOwnerService.getOwners(spOwnerService.getDeviceCodes())
                .stream()
                .filter(spOwner -> spOwner.getDwtype()==7)
                .map(SpOwner::getOwnerCode)
                .collect(Collectors.toList());
        return baseMapper.selectList(Wrappers.<SpEf2017>query()
                .select("device_code", "time", "data1","clr",
                        "IF(clsj = '0000-00-00 00:00:00', '1997-01-01 00:00:00', clsj) AS clsj",
                        "clnr", "clzt", "clwb")
                .in("device_code", codes)
        );
    }




    @Override
    public String getAlarmName(String data1) {
        switch (data1) {
            case "EF1":
                return "过压报警";
            case "EF2":
                return "低压报警";
            case "EF3":
                return "过流报警";
            case "EF4":
                return "漏电报警";
            case "EF5":
                return "1号线缆温度超高";
            case "EF6":
                return "2号线缆温度超高";
            case "EF7":
                return "3号线缆温度超高";
            default:
                return "";
        }
    }

}
